-- Created on 3/14/2020 by DIEGO 


SELECT * FROM TCONTRATO;

SELECT * FROM USER_CONSTRAINTS;

SELECT * FROM ALL_CONSTRAINTS;

-------------------------------------------

CREATE TABLE TCIDADE (
  COD_CIDADE INTEGER NOT NULL, 
  NOME VARCHAR2(40), 
  CONSTRAINT PK_CIDADE PRIMARY KEY (COD_CIDADE)
);


CREATE TABLE TBAIRRO (
  COD_CIDADE INTEGER NOT NULL, 
  COD_BAIRRO INTEGER NOT NULL, 
  NOME VARCHAR2(20),
  CONSTRAINT PK_BAIRRO PRIMARY KEY (COD_CIDADE, COD_BAIRRO)
);


ALTER TABLE TBAIRRO 
ADD CONSTRAINT FK_COD_CIDADE
FOREIGN KEY (COD_CIDADE) 
REFERENCES TCIDADE (COD_CIDADE);


CREATE TABLE TRUA (
  COD_RUA INTEGER NOT NULL, 
  COD_CIDADE INTEGER, 
  COD_BAIRRO INTEGER, 
  NOME VARCHAR2(40),
  CONSTRAINT PK_RUA PRIMARY KEY (COD_RUA)
);


ALTER TABLE TRUA 
ADD CONSTRAINT FK_CidadeBairro 
FOREIGN KEY (COD_CIDADE, COD_BAIRRO)
REFERENCES TBAIRRO (COD_CIDADE, COD_BAIRRO);


CREATE TABLE TPESSOA (
  COD_PESSOA INTEGER, 
  TIPO VARCHAR2(1) NOT NULL, 
  NOME VARCHAR2(30) NOT NULL, 
  PESSOA VARCHAR2(1) NOT NULL, 
  COD_RUA INTEGER NOT NULL, 
  CPF VARCHAR2(15), 
  CONSTRAINT PK_PESSOA PRIMARY KEY (COD_PESSOA)
);


ALTER TABLE TPESSOA ADD CONSTRAINT UK_CPF UNIQUE (CPF);

ALTER TABLE TPESSOA ADD CONSTRAINT FK_PESSOA_RUA FOREIGN KEY (COD_RUA) REFERENCES TRUA;


INSERT INTO TCIDADE VALUES (1, 'RECIFE');
INSERT INTO TCIDADE VALUES (2, 'OLINDA');
INSERT INTO TCIDADE VALUES (3, 'JABOATO');
INSERT INTO TCIDADE VALUES (4, 'PAULISTA');
INSERT INTO TCIDADE VALUES (5, 'GRAVATA');

SELECT * FROM TCIDADE;


INSERT INTO TBAIRRO VALUES (1, 1, 'CENTRO');
INSERT INTO TBAIRRO VALUES (2, 1, 'INTERIOR');
INSERT INTO TBAIRRO VALUES (3, 1, 'METRPOLE');
INSERT INTO TBAIRRO VALUES (4, 1, 'MEGALPOLE');
INSERT INTO TBAIRRO VALUES (5, 1, 'CENTRO');
INSERT INTO TBAIRRO VALUES (6, 1, 'SUBRBIO'); -- ERRO DE CHAVE

SELECT * FROM TBAIRRO;


INSERT INTO TRUA VALUES (1, 1, 1, 'ALMIRANTE');
INSERT INTO TRUA VALUES (2, 2, 1, 'DIAS FERNANDES');
INSERT INTO TRUA VALUES (3, 3, 1, 'BERNARDO VIEIRA DE MELO');
INSERT INTO TRUA VALUES (4, 3, 1, 'ADOLFO FERREIRA');

SELECT * FROM TRUA;


-- CHECK

SELECT * FROM TPESSOA;

ALTER TABLE TPESSOA ADD CONSTRAINT CK_PESSOA_TIPO CHECK (TIPO IN ('C', 'F'));

ALTER TABLE TPESSOA ADD CONSTRAINT CK_PESSOA_JF CHECK (PESSOA IN ('J', 'F'));


-- DROP CONSTRAINT 
ALTER TABLE TPESSOA DROP CONSTRAINT NOME_CONSTRAINT;

INSERT INTO TPESSOA VALUES (1, 'C', 'DIEGO FERREIRA', 'F', 1, '12345678912');
INSERT INTO TPESSOA VALUES (2, 'F', 'ORACLE CORPORATION', 'J', 2, '23322365891527');
INSERT INTO TPESSOA VALUES (3, 'C', 'MARIA FERNANDA', 'F', 1, '12345678911');
INSERT INTO TPESSOA VALUES (4, 'F', 'C&A CORP', 'J', 3, '12545636987548');
INSERT INTO TPESSOA VALUES (4, 'H', 'PAULA GARCIA', 'J', 2, '12345678912555'); -- ERRO CHECK 


ALTER TABLE TPESSOA DROP CONSTRAINT NOME_CONSTRAINT 
CASCADE CONSTRAINT; 


SELECT * FROM TCONTRATO;

ALTER TABLE TCONTRATO 
ADD CONSTRAINT CK_CONTRATO_DESCONTO 
CHECK (DESCONTO BETWEEN 0 AND 50);


ALTER TABLE TPESSOA DISABLE CONSTRAINT UK_CPF;
ALTER TABLE TPESSOA ENABLE CONSTRAINT UK_CPF;


ALTER TABLE TPESSOA 
DROP CONSTRAINT UK_CPF 
CASCADE CONSTRAINT;  -- As vezes  necessrio

SELECT * FROM USER_CONSTRAINTS WHERE TABLE_NAME = 'TPESSOA';

   
SELECT CONSTRAINT_NAME, COLUMN_NAME FROM USER_CONS_COLUMNS WHERE TABLE_NAME = 'TPESSOA';

