-- Created on 2/29/2020 by DIEGO 


DECLARE
  HORA VARCHAR2(2);
  H    NUMBER;
BEGIN
  H := TO_NUMBER(TO_CHAR(SYSDATE, 'HH24'));
  dbms_output.put_line(H || '  ' || TO_CHAR(SYSDATE, 'DAY'));
END;  


BEGIN
  IF(TO_CHAR(SYSDATE, 'DAY') IN ('SATURDAY', 'SUNDAY') 
  OR TO_NUMBER(TO_CHAR(SYSDATE, 'HH24')) NOT BETWEEN 8 AND 18) THEN
  RAISE_APPLICATION_ERROR(-20001, 'FORA DO HORRIO COMERCIAL');
  END IF;
END;



CREATE OR REPLACE TRIGGER VALIDA_HORARIO_CURSO
BEFORE INSERT OR DELETE ON TCONTRATO
BEGIN
  IF (TO_CHAR(SYSDATE, 'D') IN (1, 7) OR TO_NUMBER(TO_CHAR(SYSDATE, 'HH24')) 
      NOT BETWEEN 8 AND 24) THEN
      RAISE_APPLICATION_ERROR(-20001, 'FORA DO HORRIO COMERCIAL');
  END IF;   
END;


INSERT INTO TCONTRATO VALUES (7665, SYSDATE, 10, 1500, NULL);

SELECT * FROM TCONTRATO;

-- TABELA PARA LOGs

CREATE TABLE LOG
(
   USUARIO VARCHAR2(30),
   HORARIO DATE,
   VALOR_ANTIGO VARCHAR2(10),
   VALOR_NOVO VARCHAR2(10)
);


-- EXEMPLO 02

CREATE OR REPLACE TRIGGER gera_log_alt
AFTER UPDATE OF TOTAL ON TCONTRATO
DECLARE
BEGIN
  INSERT INTO LOG (USUARIO, HORARIO) VALUES (USER, SYSDATE);
END;


SELECT * FROM TCONTRATO;
UPDATE TCONTRATO SET TOTAL = 3000 WHERE COD_CONTRATO = 1;

SELECT * FROM LOG;


/* EXEMPLO 03
 
 UMA TRIGGER COM AS 3 OPERAES*/


CREATE OR REPLACE TRIGGER VALIDA_HORARIO_CURSO2 
BEFORE INSERT OR UPDATE OR DELETE ON TCONTRATO
BEGIN
  IF ( TO_CHAR(SYSDATE, 'D') IN (1, 7) OR TO_NUMBER(TO_CHAR(SYSDATE, 'HH24')) NOT BETWEEN 8 AND 10 ) THEN
    IF ( INSERTING ) THEN
      RAISE_APPLICATION_ERROR (-20001, 'No Pode Inserir!');
    ELSIF ( DELETING ) THEN
      RAISE_APPLICATION_ERROR (-20002, 'No Pode Remover!');
    ELSIF ( UPDATING('TOTAL') ) THEN
      RAISE_APPLICATION_ERROR (-20003, 'No Pode Alterar o Total!');
    ELSE
      RAISE_APPLICATION_ERROR (-20004, 'No Pode Alterar!');  
     END IF;
   END IF;         
END;



ALTER TRIGGER VALIDA_HORARIO_CURSO DISABLE;

DELETE FROM TCONTRATO;
UPDATE TCONTRATO SET TOTAL = 5000 WHERE COD_CONTRATO = 1;
INSERT INTO TCONTRATO VALUES (90, SYSDATE, 10, 1500, NULL);


-- EXEMPLO 04


ALTER TABLE LOG ADD OBS VARCHAR2(80);
ALTER TABLE TALUNO ADD SALARIO NUMERIC(12, 2);


CREATE OR REPLACE TRIGGER AUDITA_ALUNO
AFTER INSERT OR DELETE OR UPDATE ON TALUNO
FOR EACH ROW
  
BEGIN
  IF( DELETING )THEN
    INSERT INTO LOG( USUARIO, HORARIO, OBS ) VALUES ( USER, SYSDATE, 'Linhas Deletadas.' );
  ELSIF( INSERTING )THEN
    INSERT INTO LOG( USUARIO, HORARIO, OBS ) VALUES ( USER, SYSDATE, 'Linhas Inseridas.' );
  ELSIF( UPDATING('SALARIO') )THEN
    INSERT INTO LOG VALUES ( :OLD.NOME, SYSDATE, :OLD.SALARIO, :NEW.SALARIO, 'Alterado o Salrio' ); 
  ELSE
    INSERT INTO LOG ( USUARIO, HORARIO, OBS ) VALUES ( USER, SYSDATE, 'Atualizao do Aluno.' );  
  END IF;    
END;


SELECT * FROM LOG;
UPDATE TALUNO SET SALARIO = 3000;

COMMIT;

SELECT * FROM TALUNO;


-- ALTER TRIGGER AUDITA_ALUNO ENABLE;
-- DROP TRIGGER AUDITA_ALUNO


-- EXEMPLO 05


CREATE OR REPLACE TRIGGER GERA_LOG_CURSO
BEFORE UPDATE OF VALOR ON TCURSO
FOR EACH ROW
BEGIN
  INSER INTO LOG ( USUARIO, HORARIO, OBS, VALOR_ANTIGO, VALOR_NOVO ) 
  VALUES ( USER, SYSDATE, 'Curso Alterado: ' || :OLD.NOME, :OLD.VALOR, :NEW.VALOR );
END;  
  

SELECT * FROM TCURSO;

UPDATE TCURSO SET VALOR = 100 WHERE VALOR > 5000;



-- EXEMPLO 06


ALTER TABLE TCONTRATO ADD VALOR_COMISSAO NUMERIC(8, 2);


CREATE OR REPLACE TRIGGER CALC_COMISSAO
BEFORE INSERT OR UPDATE OF TOTAL ON TCONTRATO
REFERENCING OLD AS ANTIGO
            NEW AS NOVO
            
FOR EACH ROW
  WHEN (NOVO.TOTAL >= 5000)
DECLARE
 vCOMISSAO NUMERIC(6, 2) := 0.15;
BEGIN
  IF (:NOVO.TOTAL <= 10000) THEN
    :NOVO.VALOR_COMISSAO := :NOVO.TOTAL * (vCOMISSAO);
  ELSE
    :NOVO.VALOR_COMISSAO := :NOVO.TOTAL * (vCOMISSAO + 0.01);  
  END IF;  
END;                 


ALTER TRIGGER VALIDA_HORARIO_CURSO2 DISABLE;


INSERT INTO TCONTRATO (COD_CONTRATO, TOTAL) VALUES (34,6000);
INSERT INTO TCONTRATO (COD_CONTRATO, TOTAL) VALUES (35,12000);
SELECT * FROM TCONTRATO;


-- EXEMPLO 07


CREATE OR REPLACE VIEW vCONTRATOS_PARES
AS SELECT COD_CONTRATO, DATA, COD_ALUNO, DESCONTO, TOTAL
   FROM TCONTRATO
   WHERE MOD( COD_CONTRATO, 2 ) = 0;
   
SELECT * FROM vCONTRATOS_PARES;


CREATE OR REPLACE TRIGGER TRI_CONTRATOS_PARES
INSTEAD OF INSERT OR DELETE OR UPDATE ON vCONTRATOS_PARES
DECLARE
BEGIN
  INSERT INTO LOG( USUARIO, HORARIO, OBS) 
  VALUES (USER, SYSDATE, 'DML da VIEW vCONTRATOS_PARES');
END;   


INSERT INTO vCONTRATOS_PARES VALUES (90, SYSDATE, 10, NULL, 5000);

SELECT * FROM LOG;

SELECT * FROM TCONTRATO;












